## igstk 4.4.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
IF(COMMAND CMAKE_POLICY)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND CMAKE_POLICY)

PROJECT( IGSTK )

# version
SET(IGSTK_VERSION_MAJOR "4")
SET(IGSTK_VERSION_MINOR "4")
SET(IGSTK_VERSION_PATCH "0")

SET (LIBRARY_OUTPUT_PATH ${IGSTK_BINARY_DIR}/bin CACHE PATH "Single output directory for building all libraries." FORCE)
SET (EXECUTABLE_OUTPUT_PATH ${IGSTK_BINARY_DIR}/bin CACHE PATH "Single output directory for building all executables." FORCE)

# Append the library version information to the library target properties.
OPTION(IGSTK_WITH_LIBRARY_VERSION "Build with library version information" OFF)
IF(IGSTK_WITH_LIBRARY_VERSION)
  SET(IGSTK_LIBRARY_PROPERTIES ${IGSTK_LIBRARY_PROPERTIES}
#   BUILD_WITH_INSTALL_RPATH OFF
#   INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/lib
#   INSTALL_NAME_DIR ${CMAKE_INSTALL_PREFIX}/lib
    VERSION ${IGSTK_VERSION_MAJOR}.${IGSTK_VERSION_MINOR}.${IGSTK_VERSION_PATCH}
    SOVERSION ${IGSTK_VERSION_MAJOR}
  )
ENDIF(IGSTK_WITH_LIBRARY_VERSION)

# Build with shared libraries
OPTION(BUILD_SHARED_LIBS "Build with shared libraries" OFF)

# Add the testing directories
OPTION(IGSTK_BUILD_TESTING "Test the project" ON)

IF(IGSTK_BUILD_TESTING)
  ENABLE_TESTING()
  INCLUDE (${CMAKE_ROOT}/Modules/Dart.cmake)
ENDIF(IGSTK_BUILD_TESTING)

SET(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

# Determine if this is development or stable version
OPTION(IGSTK_DEVELOPMENT_VERSION "Set IGSTK version to development" ON)

#
#  FIND ITK
#
FIND_PACKAGE(ITK)
IF (USE_ITK_FILE)
  INCLUDE (${USE_ITK_FILE})
ELSE (USE_ITK_FILE)
  MESSAGE( FATAL_ERROR "This application requires ITK. One of these components is missing. Please verify configuration")
ENDIF (USE_ITK_FILE)

IF( ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR} VERSION_LESS 4.0 )
  SET(ITK_PRE4_VERSION 1)
ELSE( ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR} VERSION_LESS 4.0 )
  SET(ITK_PRE4_VERSION 0)
ENDIF( ${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR} VERSION_LESS 4.0 )
   
#
# FIND VTK
#
FIND_PACKAGE(VTK)
IF (USE_VTK_FILE)
  INCLUDE (${USE_VTK_FILE})
ELSE (USE_VTK_FILE)
  MESSAGE( FATAL_ERROR "This application requires VTK. One of these components is missing. Please verify configuration")
ENDIF (USE_VTK_FILE)


#
# FIND FLTK
#
OPTION(IGSTK_USE_FLTK "Use FLTK (The Fast Light Toolkit) for GUI" OFF)
IF(IGSTK_USE_FLTK)
  FIND_PACKAGE(FLTK)
  IF (FLTK_FOUND)
    INCLUDE_DIRECTORIES (${FLTK_INCLUDE_DIR})
    IF(WIN32)
      ADD_DEFINITIONS(-DWIN32)
    ENDIF(WIN32)
    LINK_LIBRARIES( ${FLTK_LIBRARIES} ${OPENGL_LIBRARIES} )
    IF(CYGWIN)
      LINK_LIBRARIES( ole32 uuid comctl32 wsock32 supc++ -lm -lgdi32)
    ENDIF(CYGWIN)
  ELSE (FLTK_FOUND)
    MESSAGE( FATAL_ERROR "This application requires FLTK. One of these components is missing. Please verify configuration")
  ENDIF (FLTK_FOUND)
ENDIF(IGSTK_USE_FLTK)

#
# FIND Qt
#
OPTION(IGSTK_USE_Qt "Use Qt for GUI" OFF)
IF(IGSTK_USE_Qt)
 # Check if VTK was built with GUISupport on
 IF( NOT VTK_USE_GUISUPPORT )
  MESSAGE(FATAL_ERROR "To build IGSTK with Qt support, you will need to use a VTK
build with GUI support i.e VTK_USE_GUISUPPORT turned on in VTK configuration")
 ENDIF( NOT VTK_USE_GUISUPPORT )

 # Check if VTK was built with Qt on
 IF( NOT VTK_USE_QVTK )
  MESSAGE(FATAL_ERROR "To build IGSTK with Qt support, you will need to use a VTK
build with Qt support i.e VTK_USE_QVTK turned on in VTK configuration")
 ENDIF( NOT VTK_USE_QVTK )

 # use what QVTK built with
 SET(QT_QMAKE_EXECUTABLE ${VTK_QT_QMAKE_EXECUTABLE} CACHE FILEPATH "")
 SET(QT_MOC_EXECUTABLE ${VTK_QT_MOC_EXECUTABLE} CACHE FILEPATH "")
 SET(QT_UIC_EXECUTABLE ${VTK_QT_UIC_EXECUTABLE} CACHE FILEPATH "")
 SET(DESIRED_QT_VERSION ${VTK_DESIRED_QT_VERSION} CACHE STRING "")

 IF( DESIRED_QT_VERSION MATCHES 3 )
    MESSAGE( FATAL_ERROR " VTK built using Qt 3. Please use Qt4" )
 ENDIF( DESIRED_QT_VERSION MATCHES 3)

 FIND_PACKAGE(Qt4 REQUIRED)

 IF(QT_USE_FILE)
   INCLUDE(${QT_USE_FILE})
 ELSE(QT_USE_FILE)
   SET(QT_LIBRARIES   ${QT_QT_LIBRARY})
 ENDIF(QT_USE_FILE)

 INCLUDE_DIRECTORIES (${QT_INCLUDE_DIR})

ENDIF(IGSTK_USE_Qt)

# The IGSTK Library
SUBDIRS(Source)

# Add the testing directories
IF(IGSTK_BUILD_TESTING)
   SUBDIRS(Testing)
ENDIF(IGSTK_BUILD_TESTING)

# Add the examples directories
OPTION(IGSTK_BUILD_EXAMPLES "Examples of the project" ON)
IF(IGSTK_BUILD_EXAMPLES)
   SUBDIRS(Examples)
ENDIF(IGSTK_BUILD_EXAMPLES)

# Connect MicronTracker
OPTION(IGSTK_USE_MicronTracker "Connect MicronTracker" OFF)

IF(IGSTK_USE_MicronTracker)
  FIND_PATH(MTC_INCLUDE_DIRECTORY MTC.h
  "C:/Program Files/Claron Technology/MicronTracker/Dist"
  DOC "Directory where the MTC.h file is located")
  INCLUDE_DIRECTORIES( ${MTC_INCLUDE_DIRECTORY} )
  INCLUDE_DIRECTORIES( ${IGSTK_SOURCE_DIR}/Utilities/MicronTracker/src )

  FIND_LIBRARY( MTC_LIBRARY
    NAMES MTC MTC.dll
    PATHS "C:/Program Files/Claron Technology/MicronTracker/Dist"
    DOC "Full path to the MTC.dll file"
    )

  IF(MTC_INCLUDE_DIRECTORY)
   INCLUDE(${IGSTK_SOURCE_DIR}/CMake/ExtractMTCVersion.cmake)
    IF( ${MTCMajorVersion}.${MTCMinorVersion} LESS 3.6.1 )
      MESSAGE( FATAL_ERROR " Your MTC version is
  ${MTCMajorVersion}.${MTCMinorVersion}. Version 3.6.1 or later should be used")
    ENDIF( ${MTCMajorVersion}.${MTCMinorVersion} LESS 3.6.1 )

    GET_FILENAME_COMPONENT( MTC_LIBRARY_DIRS ${MTC_LIBRARY} PATH )
    LINK_DIRECTORIES( ${MTC_LIBRARY_DIRS} )
  ENDIF(MTC_INCLUDE_DIRECTORY)
ENDIF(IGSTK_USE_MicronTracker)
# Connect InfiniTrack
OPTION(IGSTK_USE_InfiniTrack "Connect InfiniTrack " OFF)

IF(IGSTK_USE_InfiniTrack)
  IF(WIN32)
    FIND_PATH(InfiniTrack_INCLUDE_DIRECTORY itkInterface.h
    "C:/Program Files/Atracsys/infiniTrack/include"
    DOC "Directory where the itkInterface.h file is located")
    INCLUDE_DIRECTORIES( ${InfiniTrack_INCLUDE_DIRECTORY} )

    FIND_LIBRARY( InfiniTrack_LIBRARY
      NAMES v9ITK.dll v9ITK
      PATHS "C:/Program Files/Atracsys/infiniTrack/lib"
      DOC "Full path to the InfiniTrack library file"
      )

    IF(InfiniTrack_INCLUDE_DIRECTORY)
      GET_FILENAME_COMPONENT( InfiniTrack_LIBRARY_DIRS ${InfiniTrack_LIBRARY} PATH )
      LINK_DIRECTORIES( ${InfiniTrack_LIBRARY_DIRS} )
    ENDIF(InfiniTrack_INCLUDE_DIRECTORY)

  ELSE(WIN32)
    MESSAGE(FATAL_ERROR " Please turn off InfiniTrack option. Only windows operating system is currently supported for InfiniTrack")
  ENDIF(WIN32)

ENDIF(IGSTK_USE_InfiniTrack)

# Connect Ascension 3DG tracker
OPTION(IGSTK_USE_Ascension3DGTracker "Connect Ascension 3D Guidance Tracker" OFF)
IF(IGSTK_USE_Ascension3DGTracker)
  OPTION(Ascension3DG_MedSafe "Use MedSafe version of the tracker" OFF)
  IF(Ascension3DG_MedSafe) # Use MedSafe version
    FIND_PATH(ATC_INCLUDE_DIRECTORY ATC3DGm.h
    "C:/Program Files/Ascension/3D Guidance medSAFE (Rev F)/3D Guidance API"
    DOC "Directory where the ATC3DGm.h file is located")
    INCLUDE_DIRECTORIES( ${ATC_INCLUDE_DIRECTORY} )

    FIND_LIBRARY( ATC_LIBRARY 
      NAMES ATC3DGm ATC3DGm.dll
      PATHS "C:/Program Files/Ascension/3D Guidance medSAFE (Rev F)/3D Guidance API"
      DOC "Full path to the ATC3DG.dll file"
      )
  ELSE(Ascension3DG_MedSafe) # Use non MedSafe version
    FIND_PATH(ATC_INCLUDE_DIRECTORY ATC3DG.h
    "C:/Program Files/Ascension/3D Guidance (Rev D)/3D Guidance API"
    DOC "Directory where the ATC3DG.h file is located")
    INCLUDE_DIRECTORIES( ${ATC_INCLUDE_DIRECTORY} )

    FIND_LIBRARY( ATC_LIBRARY 
      NAMES ATC3DG ATC3DG.dll
      PATHS "C:/Program Files/Ascension/3D Guidance (Rev D)/3D Guidance API"
      DOC "Full path to the ATC3DG.dll file"
      )
  ENDIF(Ascension3DG_MedSafe)
  
  GET_FILENAME_COMPONENT( ATC_LIBRARY_DIRS ${ATC_LIBRARY} PATH )
  LINK_DIRECTORIES( ${ATC_LIBRARY_DIRS} )
ENDIF(IGSTK_USE_Ascension3DGTracker)


#
# Use OpenIGTLink protocol
#
OPTION(IGSTK_USE_OpenIGTLink "Use the OpenIGTLink protocol" OFF)
IF(IGSTK_USE_OpenIGTLink)
  #
  #  FIND OpenIGTLink
  #
  FIND_PACKAGE(OpenIGTLink)
  IF (OpenIGTLink_USE_FILE)
    INCLUDE (${OpenIGTLink_USE_FILE})
  ELSE (OpenIGTLink_USE_FILE)
    MESSAGE( FATAL_ERROR "This application requires OpenIGTLink. One of these components is missing. Please verify configuration")
  ENDIF (OpenIGTLink_USE_FILE)
ENDIF(IGSTK_USE_OpenIGTLink)

#
# Use OpenCV
#
OPTION(IGSTK_USE_OpenCV "Use the OpenCV library" OFF)
IF(IGSTK_USE_OpenCV)
  #
  #  FIND OpenCV
  FIND_PACKAGE( OpenCV REQUIRED )
ENDIF(IGSTK_USE_OpenCV)


#
# This option enables the scene graph observer to collect relavant events to constuct the scene graph tree
#
OPTION(IGSTK_USE_SceneGraphVisualization "Enable scene graph visualization by allowing the observer to listen to relevant events" ON)
IF(IGSTK_USE_SceneGraphVisualization)
  INCLUDE_DIRECTORIES( ${IGSTK_SOURCE_DIR}/Utilities/SceneGraphVisualization )
ENDIF(IGSTK_USE_SceneGraphVisualization)

#-----------------------------------------------------------------------------
# IGSTK build video imager classes
OPTION(IGSTK_USE_VideoImager "Build video imager classes are under review and not fully tested yet" OFF)

IF(IGSTK_USE_VideoImager)
  MESSAGE("Warning: Video imager classes are under review and not fully tested yet")
ENDIF(IGSTK_USE_VideoImager)

#-----------------------------------------------------------------------------
# Configure the default IGSTK_DATA_ROOT for the location of IGSTK Data.
FIND_PATH(IGSTK_DATA_ROOT igstkDataReadMe.txt ${IGSTK_SOURCE_DIR}/Testing/Data $ENV{IGSTK_DATA_ROOT})
MARK_AS_ADVANCED(IGSTK_DATA_ROOT)

#-----------------------------------------------------------------------------
# The entire IGSTK tree should use the same include path, except for the
# Wrapping directory.

# Create the list of include directories needed for IGSTK header files.
INCLUDE(${IGSTK_SOURCE_DIR}/igstkIncludeDirectories.cmake)

# This should be the only INCLUDE_DIRECTORIES command in the entire
# tree, except for the Utilities and Wrapping directories.  We need to
# do this in one place to make sure the order is correct.
INCLUDE_DIRECTORIES(
  ${ITK_DIR}/Utilities/zlib
  ${IGSTK_INCLUDE_DIRS_BUILD_TREE}
  ${IGSTK_INCLUDE_DIRS_BUILD_TREE_CXX}
  ${IGSTK_INCLUDE_DIRS_SYSTEM}
)

#-----------------------------------------------------------------------------
# check for header files that we need
INCLUDE (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)
# for serial communication: termio.h or termios.h?
CHECK_INCLUDE_FILE("termios.h"       HAVE_TERMIOS_H)
CHECK_INCLUDE_FILE("termio.h"        HAVE_TERMIO_H)

# Configure a header needed by igstkSystemInformation.
CONFIGURE_FILE("${IGSTK_SOURCE_DIR}/igstkConfigure.h.in"
               "${IGSTK_BINARY_DIR}/igstkConfigure.h")

#-----------------------------------------------------------------------------
# Help other projects use IGSTK.
SET(IGSTK_LIBRARY_PATH ${LIBRARY_OUTPUT_PATH})


# Copy the UseIGSTK.cmake file to the binary tree for backward compatability.
CONFIGURE_FILE(${IGSTK_SOURCE_DIR}/UseIGSTK.cmake.in
               ${IGSTK_BINARY_DIR}/UseIGSTK.cmake COPYONLY IMMEDIATE)

# Save the compiler settings so another project can import them.
INCLUDE(${CMAKE_ROOT}/Modules/CMakeExportBuildSettings.cmake)
CMAKE_EXPORT_BUILD_SETTINGS(${IGSTK_BINARY_DIR}/IGSTKBuildSettings.cmake)

#-----------------------------------------------------------------------------
# Installation vars.
# IGSTK_INSTALL_BIN_DIR          - binary dir (executables)
# IGSTK_INSTALL_LIB_DIR          - library dir (libs)
# IGSTK_INSTALL_DATA_DIR         - share dir (say, examples, data, etc)
# IGSTK_INSTALL_INCLUDE_DIR      - include dir (headers)
# IGSTK_INSTALL_PACKAGE_DIR      - package/export configuration files

IF(NOT IGSTK_INSTALL_BIN_DIR)
   SET(IGSTK_INSTALL_BIN_DIR
      ${CMAKE_INSTALL_PREFIX}/bin
   )
ENDIF(NOT IGSTK_INSTALL_BIN_DIR)

IF(NOT IGSTK_INSTALL_LIB_DIR)
   SET(IGSTK_INSTALL_LIB_DIR
      ${CMAKE_INSTALL_PREFIX}/lib/IGSTK
   )
ENDIF(NOT IGSTK_INSTALL_LIB_DIR)

IF(NOT IGSTK_INSTALL_DATA_DIR)
   SET(IGSTK_INSTALL_DATA_DIR
      ${CMAKE_INSTALL_PREFIX}/share/IGSTK
   )
ENDIF(NOT IGSTK_INSTALL_DATA_DIR)

=== Examples/CMakeLists.txt ===
#
# Examples that do not require GUI
#

SUBDIRS(
 TransformReaders
 TransformWriters
 TrackerConfiguration
 Tools
 TrackerDataLogger
)



#
# Examples that require FLTK
#
IF(IGSTK_USE_FLTK)
  SUBDIRS(
    HelloWorld
    OneViewAndTracking
    FourViewsAndTracking
    TrackingVolumeViewer 
    NeedleBiopsy
    Navigator
    PivotCalibrationFLTKWidget
   )

   IF(IGSTK_USE_MicronTracker)
     SUBDIRS(OneViewAndTrackingUsingMicronTracker)
   ENDIF(IGSTK_USE_MicronTracker)
ENDIF(IGSTK_USE_FLTK)

IF(IGSTK_USE_Qt)
   IF(IGSTK_USE_MicronTracker)
     SUBDIRS(OneViewAndTrackingUsingQTWidgetAndMicronTracker)
   ENDIF(IGSTK_USE_MicronTracker)
ENDIF(IGSTK_USE_Qt)

IF (IGSTK_USE_OpenIGTLink)
    SUBDIRS(  OpenIGTLinkTrackerBroadcasting )
    SUBDIRS(  OpenIGTLinkConfigurationReaders )
ENDIF (IGSTK_USE_OpenIGTLink)


IF(IGSTK_USE_VideoImager)
 IF( WIN32 )
   IF (IGSTK_USE_OpenCV)
      SUBDIRS( VideoFrameGrabberAndViewerWebcam )
   ENDIF (IGSTK_USE_OpenCV)
 ENDIF( WIN32 )

 IF(IGSTK_USE_OpenIGTLink)
  SUBDIRS( VideoFrameGrabberAndViewerOpenIGTLink )
 ENDIF(IGSTK_USE_OpenIGTLink)

ENDIF(IGSTK_USE_VideoImager)

=== Source/CMakeLists.txt ===
#
#  Define the list of source files forming the IGSTK Library
#
# The header files

SET(IGSTK_HEADS
  igstkUSImageObject.h
  igstkUSImageObjectRepresentation.h
  igstkUSImageReader.h
  igstkAnnotation2D.h
  igstkAxesObject.h
  igstkAxesObjectRepresentation.h
  igstkBoxObject.h
  igstkBoxObjectRepresentation.h
  igstkConeObject.h
  igstkConeObjectRepresentation.h
  igstkImageReader.h
  igstkDICOMImageReader.h
  igstkCTImageReader.h
  igstkMRImageReader.h
  igstkImageSpatialObject.h
  igstkCTImageSpatialObject.h
  igstkMRImageSpatialObject.h
  igstkImageSpatialObjectRepresentation.h
  igstkCTImageSpatialObjectRepresentation.h
  igstkMRImageSpatialObjectRepresentation.h
  igstkLandmark3DRegistration.h
  igstkLandmark3DRegistrationErrorEstimator.h
  igstkAuroraTracker.h
  igstkAuroraTrackerTool.h
  igstkBinaryData.h
  igstkCommunication.h
  igstkCylinderObject.h
  igstkCylinderObjectRepresentation.h
  igstkEllipsoidObject.h  
  igstkEllipsoidObjectRepresentation.h  
  igstkEvents.h
  igstkMacros.h
  igstkMeshObject.h
  igstkMeshObjectRepresentation.h
  igstkMultipleOutput.h
  igstkNDICommandInterpreter.h
  igstkNDIErrorEvent.h
  igstkObjectRepresentation.h
  igstkObject.h
  igstkPolarisTracker.h
  igstkPolarisTrackerTool.h
  igstkPulseGenerator.h
  igstkRenderWindowInteractor.h
  igstkRealTimeClock.h
  igstkSerialCommunication.h
  igstkSerialCommunicationSimulator.h
  igstkSpatialObject.h
  igstkStateMachine.h
  igstkStateMachineInput.h
  igstkStateMachineState.h
  igstkTimeStamp.h
  igstkTransform.h
  igstkTransformBase.h
  igstkToken.h
  igstkTracker.h
  igstkTrackerTool.h
  igstkTubeObject.h
  igstkTubeObjectRepresentation.h
  igstkUltrasoundProbeObject.h
  igstkUltrasoundProbeObjectRepresentation.h
  igstkVTKLoggerOutput.h
  igstkSpatialObjectReader.h
  igstkTubeReader.h
  igstkMeshReader.h
  igstkGroupObject.h
  igstkLogger.h
  igstkCoordinateSystem.h
  igstkCoordinateSystemDelegator.h
  igstkCoordinateSystemTransformToResult.h
  igstkCoordinateSystemTransformToErrorResult.h
  igstkCoordinateSystemInterfaceMacros.h
  igstkCoordinateSystemSetTransformResult.h

  igstkCircularSimulatedTracker.h
  igstkSimulatedTrackerTool.h
  igstkSimulatedTracker.h
  igstkNDITracker.h

  igstkAffineTransform.h
  igstkPerspectiveTransform.h

  igstkView.h
  igstkView2D.h
  igstkView3D.h

# Ascension tracker support
  igstkAscensionCommandInterpreter.h
  igstkAscensionTracker.h
  igstkAscensionTrackerTool.h

# Reslicing component support
  igstkReslicerPlaneSpatialObject.h
  igstkToolProjectionSpatialObject.h
  igstkToolProjectionObjectRepresentation.h
  igstkMeshResliceObjectRepresentation.h
  igstkImageResliceObjectRepresentation.h

  igstkCrossHairSpatialObject.h
  igstkCrossHairObjectRepresentation.h

  igstkPivotCalibrationAlgorithm.h

  igstkPivotCalibration.h

  igstkPETImageReader.h
  igstkPETImageSpatialObject.h
  igstkPETImageSpatialObjectRepresentation.h
)

IF(IGSTK_USE_FLTK)
  SET(IGSTK_HEADS
    ${IGSTK_HEADS}
    igstkFLTKTextBufferLogOutput.h
    igstkFLTKTextLogOutput.h
    igstkMouseTracker.h
    igstkMouseTrackerTool.h
    igstkFLTKWidget.h
    igstkPivotCalibrationFLTKWidget.h
    )
ENDIF(IGSTK_USE_FLTK)

IF(IGSTK_USE_Qt)
  SET(IGSTK_HEADS
      ${IGSTK_HEADS}
      igstkQMouseTracker.h
      igstkQMouseTrackerTool.h
      igstkQTWidget.h
   )
ENDIF(IGSTK_USE_Qt)

IF(IGSTK_USE_MicronTracker)
  SET(IGSTK_HEADS
      ${IGSTK_HEADS}
      igstkMicronTracker.h
      igstkMicronTrackerTool.h
     )
ENDIF(IGSTK_USE_MicronTracker)

IF(IGSTK_USE_InfiniTrack)
  SET(IGSTK_HEADS
      ${IGSTK_HEADS}
      igstkInfiniTrackTracker.h
      igstkInfiniTrackTrackerTool.h
     )
ENDIF(IGSTK_USE_InfiniTrack)

IF(IGSTK_USE_Ascension3DGTracker)
  SET(IGSTK_HEADS
      ${IGSTK_HEADS}
      igstkAscension3DGTracker.h
      igstkAscension3DGTrackerTool.h
     )
ENDIF(IGSTK_USE_Ascension3DGTracker)



IF(IGSTK_USE_OpenIGTLink)
    SET(IGSTK_HEADS
      ${IGSTK_HEADS}
      igstkTrackerToolObserverToOpenIGTLinkRelay.h
      )
ENDIF(IGSTK_USE_OpenIGTLink)

IF(IGSTK_USE_VideoImager)
    SET(IGSTK_HEADS
        ${IGSTK_HEADS}
        igstkVideoImager.h
        igstkVideoImagerTool.h
        igstkFrame.h
        igstkVideoFrameSpatialObject.h
        igstkVideoFrameRepresentation.h
        )

  IF(IGSTK_USE_OpenIGTLink)
    SET(IGSTK_HEADS
       ${IGSTK_HEADS}
       igstkOpenIGTLinkVideoImager.h
       igstkOpenIGTLinkVideoImagerTool.h
       )
  ENDIF(IGSTK_USE_OpenIGTLink)

  IF(WIN32)
    IF(IGSTK_USE_OpenCV)
      SET(IGSTK_HEADS
        ${IGSTK_HEADS}
        igstkWebcamWinVideoImager.h
        igstkWebcamWinVideoImagerTool.h
        )
    ENDIF(IGSTK_USE_OpenCV)
  ENDIF(WIN32)

ENDIF(IGSTK_USE_VideoImager)

# The implementation files

SET(IGSTK_SRCS  
  igstkUSImageObject.cxx
  igstkUSImageObjectRepresentation.cxx
  igstkUSImageReader.cxx
  igstkMR3DImageToUS3DImageRegistration.cxx
  igstkAnnotation2D.cxx
  igstkAxesObject.cxx
  igstkAxesObjectRepresentation.cxx
  igstkBoxObject.cxx
  igstkBoxObjectRepresentation.cxx
  igstkConeObject.cxx
  igstkConeObjectRepresentation.cxx
  igstkImageReader.txx
  igstkDICOMImageReader.txx
  igstkCTImageReader.cxx
  igstkMRImageReader.cxx
  igstkImageSpatialObject.txx
  igstkCTImageSpatialObject.cxx
  igstkMRImageSpatialObject.cxx
  igstkImageSpatialObjectRepresentation.txx
  igstkCTImageSpatialObjectRepresentation.cxx
  igstkMRImageSpatialObjectRepresentation.cxx
  igstkLandmark3DRegistration.cxx
  igstkLandmark3DRegistrationErrorEstimator.cxx
  igstkAuroraTracker.cxx
  igstkAuroraTrackerTool.cxx
  igstkBinaryData.cxx
  igstkCommunication.cxx
  igstkCylinderObject.cxx
  igstkCylinderObjectRepresentation.cxx
  igstkEllipsoidObject.cxx
  igstkEllipsoidObjectRepresentation.cxx
  igstkMeshObject.cxx
  igstkMeshObjectRepresentation.cxx
  igstkMultipleOutput.cxx
  igstkNDICommandInterpreter.cxx
  igstkObject.cxx
  igstkObjectRepresentation.cxx
  igstkPolarisTracker.cxx
  igstkPolarisTrackerTool.cxx
  igstkPulseGenerator.cxx
  igstkRenderWindowInteractor.cxx
  igstkRealTimeClock.cxx
  igstkSerialCommunication.cxx
  igstkSerialCommunicationSimulator.cxx
  igstkSpatialObject.cxx
  igstkStateMachine.txx
  igstkTimeStamp.cxx
  igstkToken.cxx
  igstkTracker.cxx
  igstkTrackerTool.cxx
  igstkTransform.cxx
  igstkTransformBase.cxx
  igstkTubeObject.cxx
  igstkTubeObjectRepresentation.cxx
  igstkUltrasoundProbeObject.cxx
  igstkUltrasoundProbeObjectRepresentation.cxx
  igstkVTKLoggerOutput.cxx
  igstkTubeReader.cxx
  igstkMeshReader.cxx
  igstkGroupObject.cxx
  igstkLogger.cxx
  igstkCoordinateSystem.cxx
  igstkCoordinateSystemDelegator.cxx
  igstkCoordinateSystemTransformToResult.cxx
  igstkCoordinateSystemTransformToErrorResult.cxx
  igstkCoordinateSystemSetTransformResult.cxx

  igstkCircularSimulatedTracker.cxx
  igstkSimulatedTrackerTool.cxx
  igstkSimulatedTracker.cxx
  igstkNDITracker.cxx

  igstkAffineTransform.cxx
  igstkPerspectiveTransform.cxx

  igstkView.cxx
  igstkView2D.cxx
  igstkView3D.cxx
  igstkViewProxyBase.cxx

# Ascension tracker support
  igstkAscensionCommandInterpreter.cxx
  igstkAscensionTracker.cxx
  igstkAscensionTrackerTool.cxx

# Reslicing component support
  igstkReslicerPlaneSpatialObject.cxx

  igstkToolProjectionSpatialObject.cxx
  igstkToolProjectionObjectRepresentation.cxx
  igstkMeshResliceObjectRepresentation.cxx
  igstkImageResliceObjectRepresentation.txx
  igstkCrossHairSpatialObject.cxx
  igstkCrossHairObjectRepresentation.cxx

  igstkPivotCalibrationAlgorithm.cxx

  igstkPivotCalibration.cxx

  igstkPETImageReader.cxx
  igstkPETImageSpatialObject.cxx
  igstkPETImageSpatialObjectRepresentation.cxx
)

IF(IGSTK_USE_FLTK)
  SET(IGSTK_SRCS  
    ${IGSTK_SRCS}
    igstkFLTKTextBufferLogOutput.cxx
    igstkFLTKTextLogOutput.cxx
    igstkMouseTracker.cxx
    igstkMouseTrackerTool.cxx
    igstkFLTKWidget.cxx
    igstkPivotCalibrationFLTKWidget.cxx
    )
ENDIF(IGSTK_USE_FLTK)

IF(IGSTK_USE_Qt)
  SET(IGSTK_SRCS
      ${IGSTK_SRCS}
      igstkQMouseTracker.cxx
      igstkQMouseTrackerTool.cxx
      igstkQTWidget.cxx
   )
ENDIF(IGSTK_USE_Qt)

IF(IGSTK_USE_MicronTracker)
  SET(IGSTK_SRCS
      ${IGSTK_SRCS}
      igstkMicronTracker.cxx
      igstkMicronTrackerTool.cxx
 
     )
ENDIF(IGSTK_USE_MicronTracker)

IF(IGSTK_USE_InfiniTrack)
  SET(IGSTK_SRCS
      ${IGSTK_SRCS}
      igstkInfiniTrackTracker.cxx
      igstkInfiniTrackTrackerTool.cxx
 
     )
ENDIF(IGSTK_USE_InfiniTrack)

IF(IGSTK_USE_Ascension3DGTracker)
  Set(IGSTK_SRCS
      ${IGSTK_SRCS}
      igstkAscension3DGTracker.cxx
      igstkAscension3DGTrackerTool.cxx
     )
ENDIF(IGSTK_USE_Ascension3DGTracker)

IF(IGSTK_USE_OpenIGTLink)
    SET(IGSTK_SRCS
      ${IGSTK_SRCS}
      igstkTrackerToolObserverToOpenIGTLinkRelay.cxx
      )
ENDIF(IGSTK_USE_OpenIGTLink)

IF(IGSTK_USE_VideoImager)
    SET(IGSTK_SRCS
        ${IGSTK_SRCS}
        igstkVideoImager.cxx
        igstkVideoImagerTool.cxx
        igstkFrame.cxx
        igstkVideoFrameSpatialObject.txx
        igstkVideoFrameRepresentation.txx
        )

  IF(IGSTK_USE_OpenIGTLink)
    SET(IGSTK_SRCS
       ${IGSTK_SRCS}
       igstkOpenIGTLinkVideoImager.cxx
       igstkOpenIGTLinkVideoImagerTool.cxx
       )
  ENDIF(IGSTK_USE_OpenIGTLink)

  IF(WIN32)
    IF(IGSTK_USE_OpenCV)
      SET(IGSTK_SRCS
        ${IGSTK_SRCS}
        igstkWebcamWinVideoImager.cxx
        igstkWebcamWinVideoImagerTool.cxx
        )
    ENDIF(IGSTK_USE_OpenCV)    
  ENDIF(WIN32)

ENDIF(IGSTK_USE_VideoImager)


IF( WIN32 )
  SET(IGSTK_HEADS ${IGSTK_HEADS} 
    igstkSerialCommunicationForWindows.h
  )
  SET(IGSTK_SRCS ${IGSTK_SRCS} 
    igstkSerialCommunicationForWindows.cxx
  )
ELSE( WIN32 )
  SET(IGSTK_HEADS ${IGSTK_HEADS} 
    igstkSerialCommunicationForPosix.h
  )
  SET(IGSTK_SRCS ${IGSTK_SRCS} 
    igstkSerialCommunicationForPosix.cxx
  )
ENDIF( WIN32 )

# Variable for holding extra libraries
SET(EXTRA_LIBS)
IF(IGSTK_USE_Qt)
  IF(APPLE)
   SET(EXTRA_LIBS ${EXTRA_LIBS} QVTK  "-framework QtTest")
  ELSE(APPLE)
    SET(EXTRA_LIBS ${EXTRA_LIBS} QVTK  ${QT_QTTEST_LIBRARY})
  ENDIF(APPLE)
ENDIF(IGSTK_USE_Qt)

IF(IGSTK_USE_MicronTracker)
  SET(EXTRA_LIBS ${EXTRA_LIBS} igstkMTCu)
ENDIF(IGSTK_USE_MicronTracker)

IF(IGSTK_USE_InfiniTrack)
  SET(EXTRA_LIBS ${EXTRA_LIBS}  v9ITK )
ENDIF(IGSTK_USE_InfiniTrack)

IF(IGSTK_USE_OpenIGTLink)
  SET(EXTRA_LIBS ${EXTRA_LIBS} OpenIGTLink)
ENDIF(IGSTK_USE_OpenIGTLink)

IF(IGSTK_USE_SceneGraphVisualization)
  SET(EXTRA_LIBS ${EXTRA_LIBS} SceneGraphVisualization)
ENDIF(IGSTK_USE_SceneGraphVisualization)

IF(IGSTK_USE_OpenCV)
  SET(EXTRA_LIBS ${EXTRA_LIBS} ${OpenCV_LIBS})
ENDIF(IGSTK_USE_OpenCV)

IF(IGSTK_USE_Ascension3DGTracker)
  SET(EXTRA_LIBS ${EXTRA_LIBS} ${ATC_LIBRARY})
ENDIF(IGSTK_USE_Ascension3DGTracker)


# Adding the IGSTK library

ADD_LIBRARY(IGSTK ${IGSTK_HEADS} ${IGSTK_SRCS})

# Linking with the FLTK, ITK and VTK libraries
TARGET_LINK_LIBRARIES( IGSTK
    ITKIO ITKBasicFilters ITKNumerics ITKCommon ITKSpatialObject
    vtkRendering vtkGraphics vtkHybrid vtkImaging 
    vtkIO vtkFiltering vtkCommon vtksys
    ${EXTRA_LIBS}
)

# Apply user-defined properties to the library target.
IF(IGSTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(IGSTK PROPERTIES
     ${IGSTK_LIBRARY_PROPERTIES}
  )
ENDIF(IGSTK_LIBRARY_PROPERTIES)

IF(IGSTK_USE_FLTK)
  TARGET_LINK_LIBRARIES( IGSTK ${FLTK_LIBRARIES} )
ENDIF(IGSTK_USE_FLTK)

INSTALL(TARGETS IGSTK
   DESTINATION ${IGSTK_INSTALL_LIB_DIR}
)

FILE(GLOB __files1 "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB __files2 "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")

INSTALL(FILES ${__files1} ${__files2}
   DESTINATION ${IGSTK_INSTALL_INCLUDE_DIR}
)

=== Testing/CMakeLists.txt ===
#Options for devices attached to serial port for testing
OPTION(IGSTK_TEST_AURORA_ATTACHED "Aurora is attached to computer" OFF)
SET( IGSTK_TEST_AURORA_PORT_NUMBER 0 CACHE STRING
     "Serial port number (0, 1, 2, 3)" )
OPTION(IGSTK_TEST_POLARIS_ATTACHED "Polaris is attached to computer" OFF)
SET( IGSTK_TEST_POLARIS_PORT_NUMBER 0 CACHE STRING
     "Serial port number (0, 1, 2, 3)" )
OPTION(IGSTK_TEST_LOOPBACK_ATTACHED "Serial Loopback is attached" OFF)
SET( IGSTK_TEST_LOOPBACK_PORT_NUMBER 1 CACHE STRING
     "Serial port number (0, 1, 2, 3)" )

OPTION(IGSTK_TEST_FLOCKOFBIRD_ATTACHED "Flock of birds is attached to computer" OFF)
SET( IGSTK_TEST_FLOCKOFBIRD_PORT_NUMBER 0 CACHE STRING
     "Serial port number (0, 1, 2, 3)" )

OPTION(IGSTK_TEST_MicronTracker_ATTACHED "MicronTracker is attached to computer" OFF)
OPTION(IGSTK_TEST_Ascension3DGTracker_ATTACHED "Ascension3DGTracker is attached to computer" OFF)

INCLUDE_DIRECTORIES (
  ${IGSTK_SOURCE_DIR}
  ${IGSTK_BINARY_DIR}
  ${IGSTK_SOURCE_DIR}/Source
  ${IGSTK_BINARY_DIR}/Source
  ${IGSTK_SOURCE_DIR}/Testing
  ${IGSTK_BINARY_DIR}/Testing
  )

#Include the cmake file that contains the testing macro. Add new tests
#in IGSTKTestingMacros file.
INCLUDE(${IGSTK_SOURCE_DIR}/Testing/IGSTKTestingMacros.cmake)

#invoke the macro with the appropriatae arguments 
SET(SANDBOX_BUILD 0)
IGSTKTesting(igstkTests
             IGSTK
             ${SANDBOX_BUILD}
             ${IGSTK_DATA_ROOT}
             ${IGSTK_BINARY_DIR}
             IGSTK_TEST_AURORA_ATTACHED
             ${IGSTK_TEST_AURORA_PORT_NUMBER}
             IGSTK_TEST_POLARIS_ATTACHED
             ${IGSTK_TEST_POLARIS_PORT_NUMBER}
             IGSTK_TEST_LOOPBACK_ATTACHED
             ${IGSTK_TEST_LOOPBACK_PORT_NUMBER}
             IGSTK_TEST_MicronTracker_ATTACHED
             IGSTK_USE_FLTK
             IGSTK_USE_Qt
             IGSTK_USE_MicronTracker
             IGSTK_USE_KWSTYLE
             IGSTK_TEST_FLOCKOFBIRD_ATTACHED
             ${IGSTK_TEST_FLOCKOFBIRD_PORT_NUMBER}
             IGSTK_USE_OpenIGTLink
             IGSTK_USE_VideoImager
             IGSTK_TEST_InfiniTrack_ATTACHED
             IGSTK_USE_Ascension3DGTracker
             IGSTK_TEST_Ascension3DGTracker_ATTACHED
             )

=== Utilities/CMakeLists.txt ===
INSTALL(FILES ${IGSTK_BINARY_DIR}/Utilities/IGSTKConfig.cmake
    DESTINATION ${IGSTK_INSTALL_PACKAGE_DIR}
    )

IF( IGSTK_USE_MicronTracker )
    SUBDIRS( MicronTracker )
ENDIF( IGSTK_USE_MicronTracker )

SUBDIRS( SceneGraphVisualization )

=== Examples/FourViewsAndTracking/CMakeLists.txt ===
PROJECT(FourViewsAndTracking)
  
SET(FourViewsAndTracking_GUI_SRCS
  FourViewsAndTrackingGUI.fl
  )
  
SET(FourViewsAndTracking_SRCS
  FourViewsAndTracking.cxx
  )


INCLUDE_DIRECTORIES(
  ${FourViewsAndTracking_SOURCE_DIR}
  ${FourViewsAndTracking_BINARY_DIR}
  )

FLTK_WRAP_UI(FourViewsAndTracking ${FourViewsAndTracking_GUI_SRCS})
ADD_EXECUTABLE(FourViewsAndTracking ${FourViewsAndTracking_FLTK_UI_SRCS} ${FourViewsAndTracking_SRCS})
TARGET_LINK_LIBRARIES(FourViewsAndTracking IGSTK)

=== Examples/HelloWorld/CMakeLists.txt ===
PROJECT(HelloWorld)
  
SET(HelloWorld_GUI_SRCS
    HelloWorldGUI.fl
    )
  
SET(HelloWorld_SRCS
   HelloWorld.cxx
   )

INCLUDE_DIRECTORIES(
  ${HelloWorld_SOURCE_DIR}
  ${HelloWorld_BINARY_DIR}
  )

FLTK_WRAP_UI(HelloWorld ${HelloWorld_GUI_SRCS})
ADD_EXECUTABLE(HelloWorld ${HelloWorld_FLTK_UI_SRCS} ${HelloWorld_SRCS})

IF(IGSTK_USE_SceneGraphVisualization)
  SET(LibrariesToLink SceneGraphVisualization)
ENDIF(IGSTK_USE_SceneGraphVisualization)

TARGET_LINK_LIBRARIES(HelloWorld ${LibrariesToLink} IGSTK)

=== Examples/Installation/CMakeLists.txt ===
# This project is designed to be built outside the Insight source tree.
PROJECT(HelloWorld)

# Find IGSTK.
FIND_PACKAGE(IGSTK REQUIRED)
IF(IGSTK_FOUND)
  INCLUDE(${IGSTK_USE_FILE})
ENDIF(IGSTK_FOUND)

ADD_EXECUTABLE(HelloWorld HelloWorld.cxx )

TARGET_LINK_LIBRARIES(HelloWorld IGSTK)

=== Examples/Navigator/CMakeLists.txt ===
PROJECT(Navigator)

INCLUDE_DIRECTORIES (
  ${IGSTK_BINARY_DIR}
  ${IGSTK_SOURCE_DIR}/Examples/TrackerConfiguration
  ${IGSTK_SOURCE_DIR}/Examples/TransformReaders
  ${IGSTK_SOURCE_DIR}/Examples/TrackerConfiguration/configurationFileReaders
  ${IGSTK_SOURCE_DIR}/Examples/Tools
) 
 
SET(Navigator_GUI_SRCS
    NavigatorGUI.fl
   )
  
SET(Navigator_SRCS
  main.cxx
  Navigator.h
  Navigator.cxx
  NavigatorQuadrantViews.h
  NavigatorQuadrantViews.cxx
)
  
IF(IGSTK_USE_MicronTracker)
  SET(Navigator_SRCS ${Navigator_SRCS}
  # MicronTracker related classes
  )
ENDIF(IGSTK_USE_MicronTracker)

INCLUDE_DIRECTORIES(
  ${Navigator_SOURCE_DIR}
  ${Navigator_BINARY_DIR}
  )

FLTK_WRAP_UI(Navigator ${Navigator_GUI_SRCS})
ADD_EXECUTABLE(Navigator ${Navigator_FLTK_UI_SRCS} ${Navigator_SRCS})
TARGET_LINK_LIBRARIES(Navigator TrackerConfiguration TransformReaders Tools IGSTK )

=== Examples/NeedleBiopsy/CMakeLists.txt ===
PROJECT(NeedleBiopsy)
  
SET(NeedleBiopsy_GUI_SRCS
  NeedleBiopsyGUI.fl
  PolarisTrackerConfigurationGUI.fl
  AuroraTrackerConfigurationGUI.fl
  MicronTrackerConfigurationGUI.fl
  )
  
SET(NeedleBiopsy_SRCS
  main.cxx
  NeedleBiopsy.h
  NeedleBiopsy.cxx
  igstkQuadrantViews.h
  igstkQuadrantViews.cxx
  igstkTrackerInitializer.h
  igstkTrackerInitializer.cxx
  igstkTrackerConfiguration.h
  igstkTrackerConfiguration.cxx
  igstkTrackerConfigurationGUIBase.h
  igstkTrackerConfigurationGUIBase.cxx
  igstkTreatmentPlan.h
  igstkTreatmentPlan.cxx
  igstkTreatmentPlanIO.h
  igstkTreatmentPlanIO.cxx
  igstkMicronTrackerConfigurationIO.h
  igstkMicronTrackerConfigurationIO.cxx
  )
  
IF(IGSTK_USE_MicronTracker)
  SET(NeedleBiopsy_SRCS ${NeedleBiopsy_SRCS}
  # MicronTracker related classes
  )
ENDIF(IGSTK_USE_MicronTracker)

INCLUDE_DIRECTORIES(
  ${NeedleBiopsy_SOURCE_DIR}
  ${NeedleBiopsy_BINARY_DIR}
  )

FLTK_WRAP_UI(NeedleBiopsy ${NeedleBiopsy_GUI_SRCS})
ADD_EXECUTABLE(NeedleBiopsy ${NeedleBiopsy_FLTK_UI_SRCS} ${NeedleBiopsy_SRCS})
TARGET_LINK_LIBRARIES(NeedleBiopsy IGSTK)

=== Examples/OneViewAndTracking/CMakeLists.txt ===
PROJECT(OneViewAndTracking)
  
SET(OneViewAndTracking_GUI_SRCS
  OneViewAndTrackingGUI.fl
  )
  
SET(OneViewAndTracking_SRCS
  OneViewAndTracking.cxx
  )

FLTK_WRAP_UI(OneViewAndTracking ${OneViewAndTracking_GUI_SRCS})
ADD_EXECUTABLE(OneViewAndTracking ${OneViewAndTracking_FLTK_UI_SRCS} ${OneViewAndTracking_SRCS})
TARGET_LINK_LIBRARIES(OneViewAndTracking IGSTK)

=== Examples/OneViewAndTrackingUsingMicronTracker/CMakeLists.txt ===
PROJECT(OneViewAndTrackingUsingMicronTracker)
  
SET(OneViewAndTrackingUsingMicronTracker_GUI_SRCS
  OneViewAndTrackingUsingMicronTrackerGUI.fl
  )
  
SET(OneViewAndTrackingUsingMicronTracker_SRCS
  OneViewAndTrackingUsingMicronTracker.cxx
  )

FLTK_WRAP_UI(OneViewAndTrackingUsingMicronTracker ${OneViewAndTrackingUsingMicronTracker_GUI_SRCS})
ADD_EXECUTABLE(OneViewAndTrackingUsingMicronTracker ${OneViewAndTrackingUsingMicronTracker_FLTK_UI_SRCS} ${OneViewAndTrackingUsingMicronTracker_SRCS})
TARGET_LINK_LIBRARIES(OneViewAndTrackingUsingMicronTracker IGSTK)

=== debian/changelog ===
igstk (4.4.0-6) unstable; urgency=medium

  * debian/rules: Do not try to install examples for arch only builds
    Closes: #733064

 -- Andreas Tille <tille@debian.org>  Wed, 25 Dec 2013 15:33:41 +0100

igstk (4.4.0-5) unstable; urgency=medium

  * *really* drop libgdcm2-dev Build-Dependency

 -- Andreas Tille <tille@debian.org>  Wed, 11 Dec 2013 15:48:19 +0100

igstk (4.4.0-4) unstable; urgency=medium

  * Drop libgdcm2-dev Build-Dependency
    Closes: #731918

 -- Andreas Tille <tille@debian.org>  Wed, 11 Dec 2013 13:47:30 +0100

igstk (4.4.0-3) unstable; urgency=medium

  * debian/control:
     - cme fix dpkg-control
     - Build-Depends: libopenigtlink-dev
       Closes: #731868
     - canonical VCS fields
     - debhelper 9
  * debian/copyright: DEP5
  * debian/watch: Adapt to new download page
  * debian/get-orig-source: There is no point in just repackaging upstream
    download tarball
  * debian/rules:
     - use dh
     - force propagation of hardening options

 -- Andreas Tille <tille@debian.org>  Wed, 11 Dec 2013 09:01:23 +0100

igstk (4.4.0-2) unstable; urgency=low

  * remove unnecessary dependencies (Closes: #640558)
  * upload to unstable

 -- Dominique Belhachemi <domibel@debian.org>  Wed, 28 Sep 2011 22:42:34 -0400

igstk (4.4.0-1) experimental; urgency=low

  * new upstream release
  * debian/rules remove redundant "--no-add-needed" option
  * remove static libraries
  * add cdbs dependency
  * compat 8

 -- Dominique Belhachemi <domibel@debian.org>  Mon, 09 May 2011 12:28:32 -0400

igstk (4.2.0-5) unstable; urgency=low

  * fixed a FTBFS on Debian GNU/kfreebsd
  * updated copyright file
  * Removed build dependency libqtwebkit-dev

 -- Dominique Belhachemi <domibel@debian.org>  Sun, 20 Mar 2011 18:06:14 -0400

=== debian/control ===
Source: igstk
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Dominique Belhachemi <domibel@debian.org>,
           Steve M. Robbins <smr@debian.org>,
           Andreas Tille <tille@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libinsighttoolkit3-dev (>= 3.20),
               libvtk5-dev,
               libqt4-dev,
               libvtk5-qt4-dev,
               libfltk1.1-dev,
               libopenigtlink-dev
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/igstk/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/igstk/trunk/
Homepage: http://www.igstk.org

Package: libigstk4-dev
Architecture: any
Section: libdevel
Depends: libigstk4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         libinsighttoolkit3-dev,
         libvtk5-dev
Suggests: libqt4-dev,
          libvtk5-qt4-dev,
          libfltk1.1-dev
Description: Toolkit for image-guided surgery applications - development
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.
 .
 This package contains the development files needed to build
 your own IGSTK applications.

Package: libigstk4
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Toolkit for image-guided surgery applications - runtime
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 .
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.

Package: libigstk4-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libigstk4 (= ${binary:Version}),
         ${misc:Depends}
Description: debugging symbols for libigstk4
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 .
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.
 .
 This package contains the debugging symbols for libigstk4.

Package: igstk-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Toolkit for image-guided surgery applications - documentation
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 .
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.
 .
 This package contains documentation files for IGstk.

Package: igstk-examples
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: libigstk4-dev
Description: Toolkit for image-guided surgery applications - examples
 The Image-Guided Surgery Toolkit (IGstk: pronounced IGStick) is a
 high-level component-based framework providing common functionality
 for image-guided surgery applications.
 .
 This software framework consists of a set of high-level components
 integrated with other low-level open source software libraries and
 application programming interfaces (API) from hardware vendors.
 .
 The cornerstone of IGstk is robustness. IGstk provides the following
 high-level functionality:
 Ability to read and display medical images including CT and MRI in
 DICOM format.
 An interface to common tracking hardware (e.g. AURORA from
 Northern Digital Inc.). A graphical user interface and visualization
 capability including a four-quadrant view (axial, sagittal, coronal,
 and 3D) as well as a multi-slice axial view (from 1 by 1 to many by
 many such as 10 by 10).
 .
 Registration: point based registration and a means for selecting
 these points. Robust common internal software services for logging,
 exception-handling and problem resolution.
 .
 This package contains examples from the IGstk source.

=== debian/rules ===
#!/usr/bin/make -f

# Set this value to 0/1 to turn off/on verbose mode.
export DH_VERBOSE=0

ABI_VERSION := 4

DEB_BUILDDIR := obj-$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

DEB_CMAKE_EXTRA_FLAGS = \
              -DCMAKE_INSTALL_PREFIX:PATH=/usr \
              -DCMAKE_BUILD_TYPE:STRING=Release \
              -DCMAKE_CXX_FLAGS="-Wno-deprecated $(CXXFLAGS)" \
              -DCMAKE_VERBOSE_MAKEFILE=$(DH_VERBOSE) \
              -DCMAKE_SHARED_LINKER_FLAGS="-Wl,--as-needed $(LDFLAGS)" \
              -DCMAKE_EXE_LINKER_FLAGS="-Wl,--as-needed $(LDFLAGS)" \
              -DCMAKE_SKIP_RPATH:BOOL=ON \
              -DIGSTK_WITH_LIBRARY_VERSION:BOOL=ON \
              -DIGSTK_DEVELOPMENT_VERSION:BOOL=ON \
              -DIGSTK_BUILD_EXAMPLES:BOOL=OFF \
              -DIGSTK_BUILD_TESTING:BOOL=ON \
              -DCMAKE_BUILD_TYPE:STRING=Release \
              -DIGSTK_USE_Qt:BOOL=ON \
              -DIGSTK_USE_FLTK:BOOL=ON \
              -DIGSTK_USE_OpenIGTLink:BOOL=ON \
              -DIGSTK_USE_OpenCV:BOOL=OFF \
              -DIGSTK_USE_MicronTracker:BOOL=OFF \
              -DBUILD_SHARED_LIBS:BOOL=ON \
              -DBUILD_DOCUMENTATION:BOOL=ON \
              -DQT_MOC_EXECUTABLE:PATH=/usr/bin/moc-qt4 \
              -DQT_UIC_EXECUTABLE:PATH=/usr/bin/uic-qt4 \
              -DQT_QMAKE_EXECUTABLE:PATH=/usr/bin/qmake

# if using precompiled static library provided by Claron Tech.:
#              -DIGSTK_USE_MicronTracker:BOOL=ON \
#              -DMTC_INCLUDE_DIRECTORY:PATH=/tmp/MTC/Dist \
#              -DMTC_LIBRARY:PATH=/tmp/MTC/Dist \ 
# TODO: /usr/bin/ld: cannot find -lMTC \

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

override_dh_auto_build-indep:
	mkdir -p $(DEB_BUILDDIR)/Utilities/Doxygen/doc/html
	$(MAKE) Documentation -C $(DEB_BUILDDIR)

override_dh_install-arch:
	dh_install
	## libigstk${ABI_VERSION}-dev ##
	dh_install -plibigstk${ABI_VERSION}-dev    debian/tmp/usr/include/IGSTK/*                       usr/include/IGSTK
#	dh_install -plibigstk${ABI_VERSION}-dev    ../../Utilities/SceneGraphVisualization/igstk*.h     usr/include/IGSTK
	#
	# install libs and *cmake files
	dh_install -plibigstk${ABI_VERSION}-dev    debian/tmp/usr/lib/IGSTK/*.so                        usr/lib
	dh_install -plibigstk${ABI_VERSION}-dev    debian/tmp/usr/lib/IGSTK/*.cmake                     usr/lib/IGSTK
	#
	## libigstk${ABI_VERSION} ##
	dh_install -plibigstk${ABI_VERSION}        debian/tmp/usr/lib/IGSTK/*.so.*                      usr/lib

override_dh_install-indep:
        # remove zero byte files
	find $(DEB_BUILDDIR)/Utilities/Doxygen/doc/ -depth -empty | xargs rm -rf
	#
	dh_install -pigstk-doc      $(DEB_BUILDDIR)/Utilities/Doxygen/doc/html       usr/share/doc/igstk-doc

override_dh_installexamples-indep:
	dh_installexamples -pigstk-examples Examples/*
	# remove executable file mode bit
	[ -d debian/igstk-examples ] && \
	find debian/igstk-examples/usr/share/doc/igstk-examples/examples \
            -type f -exec chmod 644 \{\} \;

override_dh_auto_test:
	# perform tests ('-' ignores return values)
	- cd $(DEB_BUILDDIR) && LD_LIBRARY_PATH=`pwd`/bin:$$LD_LIBRARY_PATH /usr/bin/xvfb-run -a /usr/bin/ctest -VV

override_dh_strip:
	dh_strip --dbg-package=libigstk${ABI_VERSION}-dbg

=== debian/watch ===
version=3
opts="uversionmangle=s/-/./" \
  http://igstk.org/IGSTK/resources/software.html .*/IGSTK-([\d\.-]+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
